/* 
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
=============================================================================== 
*/ 
 
#include "../include/common.h"  
#include "../include/dialogs.h" 

void OzEDIT_AboutDialog();
void OzEDIT_ErrorDialog(char *,void *);
void OzEDIT_InfoDialog(char *,void *);
gint OzEDIT_AreYouSureDialog(char *,void *);

/* == OzEDIT_AreYouSureDialog() ==================================================== */
gint OzEDIT_AreYouSureDialog(char *v_message,void *v_args) {
    GtkWidget *areyousure_dialog;
    gint response;
    areyousure_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,v_message,v_args);
    response = gtk_dialog_run(GTK_DIALOG(areyousure_dialog));
    gtk_widget_destroy(areyousure_dialog);
    return response;
}


/* == OzEDIT_AboutDialog() ==================================================== */
void OzEDIT_AboutDialog() {
    GtkWidget *about_dialog,*logo_image;
    GdkPixmap *logo_pixmap;
    GdkBitmap *logo_mask;
    GtkStyle *logo_style;

    about_dialog = gtk_dialog_new_with_buttons ("About OzEDITor",NULL,
                                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                                  GTK_STOCK_OK,
                                                  GTK_RESPONSE_ACCEPT,
                                                  NULL);
    gtk_window_set_title(GTK_WINDOW(about_dialog),"About OzEDITor...");
    gtk_widget_realize(about_dialog);
    gtk_container_set_border_width(GTK_CONTAINER(about_dialog), 1);
	
    logo_style = gtk_widget_get_style(about_dialog);
    logo_pixmap = gdk_pixmap_create_from_xpm_d(about_dialog->window,&logo_mask,&logo_style->bg[GTK_STATE_NORMAL],(gchar **)logo_xpm);
    logo_image = gtk_image_new_from_pixmap(logo_pixmap, logo_mask);

    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(about_dialog)->vbox),logo_image,TRUE,TRUE,0);
    gtk_widget_show(logo_image);
    gtk_widget_show(about_dialog);
    gtk_dialog_run(GTK_DIALOG(about_dialog));
    gtk_widget_destroy(about_dialog);
}

/* == OzEDIT_ErrorDialog() ========================================================= */
void OzEDIT_ErrorDialog(char *v_message,void *v_args) {
    GtkWidget *error_dialog;
    error_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR,GTK_BUTTONS_CLOSE,v_message,v_args);
    gtk_dialog_run (GTK_DIALOG(error_dialog));
    gtk_widget_destroy(error_dialog);
    return;
}

/* == OzEDIT_InfoDialog() ========================================================= */
void OzEDIT_InfoDialog(char *v_message,void *v_args) {
    GtkWidget *info_dialog;
    info_dialog = gtk_message_dialog_new(NULL,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,v_message,v_args);
    gtk_dialog_run (GTK_DIALOG(info_dialog));
    gtk_widget_destroy(info_dialog);
    return;
}
