/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================
*/

#include "../include/common.h"
#include "../include/main.h"

#define FONT "-misc-fixed-medium-r-normal--12-200-75-75-c-100-iso8859-1"


/* ==== Quit  ============================================================================================== */
gint OzEDIT_CBQuit(GtkWidget *widget,GdkEvent *event,gpointer data) {
    gtk_main_quit();
    return FALSE;
}

/* ==== New Object ========================================================================================= */
gint OzEDIT_CBNew(GtkWidget *widget,GdkEvent *event,gpointer data) {
    OzEDIT_CreateNewObject((gchar *)NULL);
    return FALSE;
}

/* ==== Open Object ========================================================================================= */
void OzEDIT_CBOpenDialogOK(GtkWidget *widget,GtkFileSelection *fs) {
    OzEDIT_CreateNewObject((gchar *)gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
}

gint OzEDIT_CBOpen(GtkWidget *widget,GdkEvent *event,gpointer data) {
    GtkWidget *file_selector;
    file_selector = gtk_file_selection_new("Please select file to open.");
    g_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button),"clicked",G_CALLBACK(OzEDIT_CBOpenDialogOK),file_selector);
    g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button),"clicked",G_CALLBACK(gtk_widget_destroy),(gpointer)file_selector);
    g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button),"clicked",G_CALLBACK(gtk_widget_destroy),(gpointer)file_selector);
    gtk_widget_show(file_selector);        
    return FALSE;
}

/* ==== Close  ============================================================================================== */
gint OzEDIT_CBClose(GtkWidget *widget,GdkEvent *event,gpointer data) {
    struct _OzEDIT_Object *object;
    
    object = (struct _OzEDIT_Object *)OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id);
    if(object == NULL) return FALSE; /* Proteggiti dagli errori degli utenti */
    if((gtk_text_buffer_get_modified(object->text_buffer))&&(OzEDIT_AreYouSureDialog("Are you sure wanna close %s ?",object->name) != GTK_RESPONSE_YES)) return FALSE;

    OzEDIT_DestroyObject(object);
}

/* ==== Save  ============================================================================================== */
gint OzEDIT_CBSave(GtkWidget *widget,GdkEvent *event,gpointer data) {
    struct _OzEDIT_Object *object;
    object = (struct _OzEDIT_Object *)OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id);
    OzEDIT_SaveObject(object,object->filename);    
    return FALSE;
}

/* ==== SaveAs  ============================================================================================== */
void OzEDIT_CBSaveAsDialogOK(GtkWidget *widget,GtkFileSelection *fs) {
    OzEDIT_SaveObject(OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id),(gchar *)gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
}

gint OzEDIT_CBSaveAs(GtkWidget *widget,GdkEvent *event,gpointer data) {
    GtkWidget *file_selector;
    file_selector = gtk_file_selection_new("Save as...");
    g_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button),"clicked",G_CALLBACK(OzEDIT_CBSaveAsDialogOK),file_selector);
    g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button),"clicked",G_CALLBACK(gtk_widget_destroy),(gpointer)file_selector);
    g_signal_connect_swapped(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button),"clicked",G_CALLBACK(gtk_widget_destroy),(gpointer)file_selector);
    gtk_widget_show(file_selector);        
    return FALSE;
}

/* ==== Config  ============================================================================================== */
gint OzEDIT_CBConfig(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBConfig - TODO"
    return FALSE;
}


/* ==== Find ============================================================================================== */
gint OzEDIT_CBFind(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBFind - TODO"
    return FALSE;
}

/* ==== Set Bookmark ============================================================================================== */
gint OzEDIT_CBSetBookmark(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBSetBookmark - TODO"
    return FALSE;
}

/* ==== Goto Bookmark ============================================================================================== */
gint OzEDIT_CBGotoBookmark(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBGotoBookmark - TODO"
    return FALSE;
}

/* ==== Info  ============================================================================================== */
gint OzEDIT_CBInfo(GtkWidget *widget,GdkEvent *event,gpointer data) {
    OzEDIT_AboutDialog();
    return FALSE;
}

/* ==== WSOpen =============================================================================================== */
gint OzEDIT_CBWSOpen(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBWSOpen - TODO"
    return FALSE;
}

/* ==== WSSave =============================================================================================== */
gint OzEDIT_CBWSSave(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBWSSave - TODO"
    return FALSE;
}

/* ==== WSClose =============================================================================================== */
gint OzEDIT_CBWSClose(GtkWidget *widget,GdkEvent *event,gpointer data) {
#warning "OzEDIT_CBWSClose - TODO"
    return FALSE;
}

/* ==== Misc CallBacks ========================================================================================= */
void OzEDIT_CBNotebookChangePage(GtkWidget *widget,GtkNotebookPage *page,guint arg,gpointer data) {
    gchar *tabtitle;
    struct _OzEDIT_Object *object;
    gint i;
    topclass.notebook_current_page = arg;
    tabtitle = gtk_notebook_get_tab_label_text(GTK_NOTEBOOK(widget),gtk_notebook_get_nth_page(GTK_NOTEBOOK(widget),topclass.notebook_current_page));
    for(i=0;i<g_list_length(topclass.objects);i++) {
	object = g_list_nth_data(topclass.objects,i);
	if(g_ascii_strcasecmp(object->name,tabtitle) == 0) topclass.current_frame_id = object->frame_id;
    }
#ifdef DEBUG
    g_print("Switched to notebook page:%d - TAB:%s - Frame ID:%d\n",topclass.notebook_current_page,tabtitle,topclass.current_frame_id);
#endif    
}

void OzEDIT_CBRowActivated(GtkTreeView *tree_view,GtkTreePath *path,GtkTreeViewColumn *column) {
#warning "OzEDIT_CBRowActivated - TODO"
}

/* ==== Popup Menu =============================================================================================== */

static void OzEDIT_CBPopupMenuActivate(gchar *menu) {
#ifdef DEBUG
    g_print("POPUP Menu %s\n",menu);
#endif    
}


#define MENU_POPUP_ITEMS 4

static char *popup_menu_items[MENU_POPUP_ITEMS][2] = {
	"Focus to this","focus_to_this",
	"Close Object","close_object",
	"Rename","rename_object",
	"Clear all Bookmarks","clear_all_bookmarks"
};

GtkWidget *OzEDIT_CreatePopupMenu() {
	GtkWidget *menu,*menu_item;
	gint i;
	
	menu = gtk_menu_new();
	
	for(i=0;i<MENU_POPUP_ITEMS;i++) {
		menu_item = gtk_menu_item_new_with_label((gchar *)popup_menu_items[i][0]);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menu_item);
		g_signal_connect_swapped(G_OBJECT(menu_item), "activate", G_CALLBACK(OzEDIT_CBPopupMenuActivate),(gpointer)popup_menu_items[i][1]);
		gtk_widget_show(menu_item);
	}
	return menu;
}

static gint OzEDIT_CBPopupMenu(GtkWidget *widget, GdkEvent *event,struct _OzEDIT_Object *object)
{
	GtkWidget *menu;
	GdkEventButton *event_button;

	g_return_val_if_fail(widget != NULL, FALSE);
	g_return_val_if_fail(event != NULL, FALSE);

	menu = OzEDIT_CreatePopupMenu();
	
	if (event->type == GDK_BUTTON_PRESS)
	{
		event_button = (GdkEventButton *)event;
		if (event_button->button == 3)
		{
	  		gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,event_button->button,event_button->time);
	 		return TRUE;
		}
	}
	return FALSE;
}

/* === ZvtTerm ========================================================================================= */
static void OzEDIT_CBConsoleSetHints(GtkWidget *term,GtkWidget *main_window)
{
	GdkGeometry hints;

	hints.base_width = (GTK_WIDGET(topclass.console)->style->xthickness * 2) + 2;
	hints.base_height = (GTK_WIDGET(topclass.console)->style->ythickness * 2);

	hints.width_inc = ZVT_TERM(topclass.console)->charwidth;
	hints.height_inc = ZVT_TERM(topclass.console)->charheight;
	hints.min_width = hints.base_width + hints.width_inc;
	hints.min_height = hints.base_height + hints.height_inc;

	gtk_window_set_geometry_hints(GTK_WINDOW(main_window),GTK_WIDGET(topclass.console),&hints,GDK_HINT_RESIZE_INC|GDK_HINT_MIN_SIZE|GDK_HINT_BASE_SIZE);
}

/* ==== Called Periodically ====================================================================================== */
gint OzEDIT_CBTimeout(gpointer data) {
    struct _OzEDIT_Object *object;
    gchar buffer[512];
    GtkTextMark *mark;
    GtkTextIter iter;
    object = OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id);
    if(object == NULL) return TRUE;
    mark = gtk_text_buffer_get_insert(object->text_buffer);
    gtk_text_buffer_get_iter_at_mark(object->text_buffer,&iter,mark);
    sprintf(buffer,"File:%s  Lines:%d  Chars:%d  Cursor: %d:%d\0",object->filename,gtk_text_buffer_get_line_count(object->text_buffer),gtk_text_buffer_get_char_count(object->text_buffer),gtk_text_iter_get_line(&iter),gtk_text_iter_get_line_offset(&iter));	
    if(gtk_text_buffer_get_modified(object->text_buffer)) {
        strcat(buffer," MODIFIED ");
    } 
    gtk_label_set_text(GTK_LABEL(object->w_entry),buffer);
    return TRUE;
}


gint OzEDIT_CBColorize(gpointer data) {
    struct _OzEDIT_Object *object;
    if(topclass.object_counter < 1) return TRUE;
    object = OzEDIT_ReturnObjectFromFrameID(topclass.current_frame_id);
    if(object == NULL) return TRUE;
    OzEDIT_ParseTextBuffer(object);
    return TRUE;
}

/* ============================================================================================ */

static GtkItemFactoryEntry menu_items[] = {
  { "/_File",         	NULL,         	NULL,           	0, "<Branch>" },
  { "/File/_New",	"<control>N", 	(GtkItemFactoryCallback)OzEDIT_CBNew,		0, "<Item>" },  
  { "/File/_Open",	"<control>O", 	(GtkItemFactoryCallback)OzEDIT_CBOpen,		0, "<Item>" },
  { "/File/_Save", 	"<control>S", 	(GtkItemFactoryCallback)OzEDIT_CBSave, 		0, "<Item>" },
  { "/File/_SaveAs", 	NULL, 		(GtkItemFactoryCallback)OzEDIT_CBSaveAs,	0, "<Item>" },
  { "/File/_Close", 	NULL, 		(GtkItemFactoryCallback)OzEDIT_CBClose,		0, "<Item>" }, 
  { "/File/sep1",     	NULL,         	NULL,           	0, "<Separator>" },
  { "/File/Configure", 	NULL,		(GtkItemFactoryCallback)OzEDIT_CBConfig,  	0, "<Item>" },
  { "/File/sep2",     	NULL,         	NULL,           	0, "<Separator>" },
  { "/File/Quit",	"<control>Q", 	(GtkItemFactoryCallback)OzEDIT_CBQuit,  	0, "<Item>" },  
  { "/_Workspace",      NULL,         	NULL,           	0, "<Branch>" },
  { "/Workspace/_Open",	NULL, 		(GtkItemFactoryCallback)OzEDIT_CBWSOpen,	0, "<Item>" },
  { "/Workspace/_Save", NULL, 		(GtkItemFactoryCallback)OzEDIT_CBWSSave, 	0, "<Item>" },
  { "/Workspace/_Close",NULL, 		(GtkItemFactoryCallback)OzEDIT_CBWSClose,	0, "<Item>" },
  { "/_Help",         	NULL,         	NULL,           	0, "<LastBranch>" },
  { "/_Help/About",   	NULL,         	(GtkItemFactoryCallback)OzEDIT_CBInfo,		0, "<Item>" },
};

static gint nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);

extern char      **environ;		
static char      **env;
static char      **env_copy;
static int         winid_pos;

int main(int argc, char *argv[])
{
	GtkWidget *w_main_window,*w_main_table,*w_main_vbox,*w_main_menubar,*w_main_toolbar,*w_main_hpaned,*w_main_vpaned,*w_scrollable,*w_frameconsole;
	GtkWidget *w_icon,*w_button_open,*w_button_new,*w_button_close,*w_console_hbox,*w_console_scrollbar;	
	GdkPixmap *v_pixmap;
	GdkBitmap *v_mask;
	GtkStyle *v_style;
	GtkItemFactory *v_item_factory;
	GtkAccelGroup *v_accel_group;
	GtkTreeViewColumn *column;
	GtkCellRenderer *renderer;	
	GString *shell, *name;
	int i, c, cmdindex, login_shell;
	char **p, *fontname=FONT;
	struct passwd *pw;

	
	gtk_init(&argc,&argv);
	
	/* Crea la Finestra Principale */
	w_main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(w_main_window),"OzEDITor");
	gtk_widget_set_size_request(GTK_WIDGET(w_main_window), 640, 480);
	g_signal_connect(G_OBJECT(w_main_window),"destroy",G_CALLBACK(OzEDIT_CBQuit),NULL);
	gtk_container_set_border_width(GTK_CONTAINER(w_main_window), 2);
	
	gtk_widget_realize(w_main_window);

	/* Table Container */
  	w_main_table = gtk_table_new(12,3,FALSE);
	gtk_container_add(GTK_CONTAINER(w_main_window), w_main_table);
	gtk_widget_show(w_main_table);

	w_main_vbox = gtk_vbox_new(FALSE,1);
	gtk_container_set_border_width(GTK_CONTAINER(w_main_vbox), 1);
	gtk_table_attach_defaults(GTK_TABLE(w_main_table),w_main_vbox,0,2,0,1);

	/* Menu */
	v_accel_group = gtk_accel_group_new();
	v_item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<main>",v_accel_group);
	gtk_item_factory_create_items(v_item_factory,nmenu_items,menu_items,NULL);
	gtk_window_add_accel_group (GTK_WINDOW(w_main_window),v_accel_group);
	w_main_menubar = gtk_item_factory_get_widget(v_item_factory, "<main>");
	gtk_widget_show(w_main_menubar);

	/* ToolBar */
	w_main_toolbar = gtk_toolbar_new();
	gtk_widget_set_size_request(GTK_WIDGET(w_main_toolbar), 640, 40);
	gtk_toolbar_set_orientation(GTK_TOOLBAR(w_main_toolbar),GTK_ORIENTATION_HORIZONTAL);
	gtk_toolbar_set_style(GTK_TOOLBAR(w_main_toolbar),GTK_TOOLBAR_ICONS);
	gtk_container_set_border_width(GTK_CONTAINER(w_main_toolbar),1);

	/* Toolbar Icons */
	gtk_toolbar_set_style(GTK_TOOLBAR(w_main_toolbar), GTK_TOOLBAR_ICONS);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_NEW,"New",NULL,(GtkItemFactoryCallback)OzEDIT_CBNew,NULL,-1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_OPEN,"Open",NULL,(GtkItemFactoryCallback)OzEDIT_CBOpen,NULL,-1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_SAVE,"Save",NULL,(GtkItemFactoryCallback)OzEDIT_CBSave,NULL,-1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_SAVE_AS,"SaveAs",NULL,(GtkItemFactoryCallback)OzEDIT_CBSaveAs,NULL,-1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_CLOSE,"Close",NULL,(GtkItemFactoryCallback)OzEDIT_CBClose,NULL,-1);
	gtk_toolbar_append_space(GTK_TOOLBAR(w_main_toolbar));
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_FIND,"Find",NULL,(GtkItemFactoryCallback)OzEDIT_CBFind,NULL,-1);
	gtk_toolbar_insert_stock(GTK_TOOLBAR(w_main_toolbar),GTK_STOCK_INDEX,"Set Bookmark",NULL,(GtkItemFactoryCallback)OzEDIT_CBSetBookmark,NULL,-1);

	gtk_toolbar_append_space(GTK_TOOLBAR(w_main_toolbar));
	
	gtk_widget_show(w_main_toolbar);

	/* Pack it all together */
	gtk_box_pack_start(GTK_BOX(w_main_vbox),w_main_menubar, FALSE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(w_main_vbox),w_main_toolbar, TRUE, TRUE, 0);

	gtk_widget_show(w_main_vbox);

	/* Main Console Widget - Per la CONSOLE */
	
	w_frameconsole = gtk_frame_new("Console");
	gtk_widget_set_size_request(w_frameconsole,640,80);
	gtk_widget_show(w_frameconsole);

	w_console_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_set_spacing(GTK_BOX(w_console_hbox), 2);
        gtk_container_set_border_width(GTK_CONTAINER(w_console_hbox), 2);

	topclass.console = zvt_term_new_with_size(80,24);
	zvt_term_set_font_name(ZVT_TERM(topclass.console), fontname); 
	zvt_term_set_blink(ZVT_TERM(topclass.console), TRUE);
	zvt_term_set_bell(ZVT_TERM(topclass.console), TRUE);
	zvt_term_set_scrollback(ZVT_TERM(topclass.console),50);
	zvt_term_set_scroll_on_keystroke(ZVT_TERM (topclass.console), TRUE);
	zvt_term_set_scroll_on_output(ZVT_TERM(topclass.console), FALSE);
	zvt_term_set_background(ZVT_TERM(topclass.console), NULL, 0, 0);
	zvt_term_set_wordclass(ZVT_TERM(topclass.console), "-A-Za-z0-9/_:.,?+%=");

        g_signal_connect_after(G_OBJECT(topclass.console),"realize",G_CALLBACK(OzEDIT_CBConsoleSetHints),w_main_window);
	gtk_widget_show(topclass.console);

	w_console_scrollbar = gtk_vscrollbar_new(GTK_ADJUSTMENT(ZVT_TERM(topclass.console)->adjustment));
	GTK_WIDGET_UNSET_FLAGS(w_console_scrollbar, GTK_CAN_FOCUS);
	gtk_widget_show(w_console_scrollbar);
	
	gtk_box_pack_start(GTK_BOX(w_console_hbox),w_console_scrollbar, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(w_console_hbox),topclass.console, 1, 1, 0);
	gtk_widget_show(w_console_hbox);

	gtk_container_add(GTK_CONTAINER(w_frameconsole), w_console_hbox);

	/* Genera la copia dell'Ambiente di Esecuzione */
	env = environ;
	for (p = env; *p; p++);
	i = p - env;
	env_copy = (char **) g_malloc (sizeof (char *) * (i + 3));
	for (i = 0, p = env; *p; p++) {
    	    if (strncmp (*p, "TERM=", 5) == 0)
		env_copy [i++] = "TERM=xterm";
    	    else if ((strncmp (*p, "COLUMNS=", 8) == 0) || (strncmp (*p, "LINES=", 6) == 0))
		continue;
    	    else
		env_copy [i++] = *p;
	}

	env_copy[i++] = "COLORTERM=zterm";
	winid_pos = i++;
	env_copy[winid_pos] = "TEST";
	env_copy[i] = NULL;

	/* Adesso Esegui la BASH */
	switch (zvt_term_forkpty(ZVT_TERM(topclass.console), ZVT_TERM_DO_UTMP_LOG | ZVT_TERM_DO_WTMP_LOG | ZVT_TERM_DO_LASTLOG)) {
	    case -1:
		perror("ERROR: unable to fork:");
		exit(1);
		break;
	    case 0:
		if (cmdindex) {
    		    environ = env_copy;
    		    execvp(argv[cmdindex], &argv[cmdindex]);
		} else {
    		    /* get shell from passwd */
    		    pw = getpwuid(getuid());
    		    if (pw) {
			shell = g_string_new(pw->pw_shell);
			if (login_shell) {
			    name = g_string_new("-");
			} else {
			    name = g_string_new("");
			}
			g_string_append(name, strrchr(pw->pw_shell, '/'));
    		    } else {
			shell = g_string_new("/bin/sh");
			if (login_shell) {
			    name = g_string_new("-sh");
			} else {
			    name = g_string_new("sh");
			}
    		    }	
    		    execle (shell->str, name->str, NULL, env_copy);
    		    perror ("Could not exec\n");
    		    _exit (127);
		}
		perror("ERROR: Cannot exec command:");
		exit(1);      
	    default:
		break;
	 }

	/* Scrollable per la LISTA TREE */
	w_scrollable =  gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(w_scrollable),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
	gtk_widget_set_size_request(GTK_WIDGET(w_scrollable), -1, 380);
	gtk_container_set_border_width(GTK_CONTAINER(w_scrollable),1);
	gtk_widget_show(w_scrollable);

	/* Tree List Widget */
	topclass.treestore = gtk_tree_store_new(2,G_TYPE_STRING,G_TYPE_STRING);
	topclass.maintree = gtk_tree_view_new_with_model(GTK_TREE_MODEL(topclass.treestore));
	g_object_unref(G_OBJECT(topclass.treestore));
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(topclass.maintree), TRUE);
	gtk_tree_selection_set_mode(gtk_tree_view_get_selection(GTK_TREE_VIEW(topclass.maintree)),GTK_SELECTION_BROWSE);
	
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes("Objects",renderer,"text", 0,NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(topclass.maintree),GTK_TREE_VIEW_COLUMN(column));
	
	g_signal_connect(GTK_TREE_VIEW(topclass.maintree),"row-activated",G_CALLBACK(OzEDIT_CBRowActivated),GTK_TREE_MODEL(topclass.treestore));
        g_signal_connect(G_OBJECT(topclass.maintree),"button_press_event",G_CALLBACK(OzEDIT_CBPopupMenu),NULL);
	
	gtk_widget_set_size_request(topclass.maintree,200,0);
	gtk_container_add(GTK_CONTAINER(w_scrollable),topclass.maintree);

	gtk_widget_show(topclass.maintree);

	/* NoteBook - Appartiene alla Classe Principale */
	topclass.notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos(GTK_NOTEBOOK(topclass.notebook), GTK_POS_TOP);
	g_signal_connect(GTK_OBJECT(topclass.notebook),"switch-page",G_CALLBACK(OzEDIT_CBNotebookChangePage),NULL);
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(topclass.notebook),TRUE);
	gtk_widget_show(topclass.notebook);

	w_main_hpaned = gtk_hpaned_new();
	gtk_paned_add1(GTK_PANED(w_main_hpaned),w_scrollable);
	gtk_paned_add2(GTK_PANED(w_main_hpaned),topclass.notebook);
	gtk_widget_show(w_main_hpaned);    

	w_main_vpaned = gtk_vpaned_new();
	gtk_table_attach_defaults(GTK_TABLE(w_main_table),w_main_vpaned, 0, 3, 1, 11);
	gtk_paned_add1(GTK_PANED(w_main_vpaned),w_main_hpaned);
	gtk_paned_add2(GTK_PANED(w_main_vpaned),w_frameconsole);
	gtk_widget_show(w_main_vpaned);    

	/* Status Bar */
	topclass.statusbar = gtk_statusbar_new();      
	gtk_table_attach_defaults(GTK_TABLE(w_main_table),topclass.statusbar,0,2,11,12);
	gtk_widget_set_size_request(GTK_WIDGET(topclass.statusbar), 640, 1);
	gtk_widget_show(topclass.statusbar);
	
	gtk_widget_show(w_main_window); 

	topclass.object_counter = 0;
    
	gtk_timeout_add(200,OzEDIT_CBTimeout,NULL);
	gtk_idle_add(OzEDIT_CBColorize,NULL);
	
	gtk_main();
}
